@echo off&setlocal EnableExtensions DisableDelayedExpansion
if "%~1"=="/?" call :help "Convert Text to PDF" &exit /b 0
set "Letter=pageHeight=792, pageWidth=612"
set "A4=pageHeight=842, pageWidth=595"
set "A3=pageHeight=1190, pageWidth=842"

set "inFile=%~1"
if not exist "%inFile%" call :help "Error: inFile does not exist.">&2 &exit /b 1
if exist "%inFile%\" call :help "Error: inFile does not exist.">&2 &exit /b 1
for %%i in ("%inFile%") do if %%~zi equ 0 call :help "Error: inFile is empty.">&2 &exit /b 1

set "outFile=%~2"
if not defined outFile call :help "Error: outFile not specified.">&2 &exit /b 1
for %%i in ("%outFile%") do if /i "%%~xi" neq ".pdf" set "outfile=%outfile%.pdf"

set /a "%A4%, tabWidth=8, fontSize=10, landscape=0, objects=5, pages=0"
:opt_loop
if "%~3"=="" goto end_opt
set "opt=%~3"
if /i "%opt%"=="/A4" (
  set /a "%A4%"
) else if /i "%opt%"=="/A3" (
  set /a "%A3%"
) else if /i "%opt%"=="/Letter" (
  set /a "%Letter%"
) else if /i "%opt:~0,3%"=="/T:" (
  set /a "tabWidth=%opt:~3%"
) else if /i "%opt:~0,3%"=="/F:" (
  set /a "fontSize=%opt:~3%"
) else if /i "%opt%"=="/L" (
  set /a "landscape=1"
) else call :help "Error: Invalid option.">&2 &exit /b 1
shift /3
goto opt_loop
:end_opt

2>&1 (>"%outFile%" type nul)|>nul find /v ""&&(call :help "Error: Unabe to write to outFile.">&2 &exit /b 1)

set "tab=	"
set "spcs=                                                                                                    "
for /f %%a in ('copy /z "%~fs0" nul') do set "cr=%%a"
if not exist "%__APPDIR__%wbem\WMIC.exe" for /f "tokens=1,2*" %%a in ('reg query "HKCU\Control Panel\International"^|findstr /i "\<[is]Date\>"') do set "%%a=%%c"
if not exist "%__APPDIR__%wbem\WMIC.exe" (
  for /f "tokens=1-6 delims=:.,%sDate%" %%a in ("%date:* =%,%time: =0%") do (
    setlocal EnableExtensions EnableDelayedExpansion
    if !iDate!==0 (set mm=0%%a&set dd=0%%b&set yy=%%c) else if !iDate!==1 (set dd=0%%a&set mm=0%%b&set yy=%%c) else (set yy=%%a&set mm=0%%b&set dd=0%%c)
    (set h=%%d&set m=%%e&set s=%%f)
  )
  if 1!yy! LSS 200 if 1!yy! LSS 170 (set yy=20!yy!) else (set yy=19!yy!)
  set "LocalDateTime=!yy!!mm:~-2!!dd:~-2!!h!!m!!s!"
) else for /f "delims=." %%a in ('WMIC OS Get LocalDateTime /value') do for /f %%b in ("%%a") do (
  set "%%b"
  setlocal EnableExtensions EnableDelayedExpansion
)

if !tabWidth! lss 2 set "tabWidth=2"
if !fontSize! lss 1 set "fontSize=1"
if !landscape! neq 0 set /a "_tmp=pageWidth, pageWidth=pageHeight, pageHeight=_tmp"
for /f %%i in ('type "!inFile!"^|find /c /v ""') do set /a "lineHight=(fontSize*12)/10, linesInPage=(pageHeight-72)/lineHight, pageCnt=%%i/linesInPage, linesInLast=%%i %% linesInPage, hMinus40=pageHeight-40"
if !linesInPage! lss 1 set "linesInPage=1"
if !linesInLast! equ 0 (set /a "linesInLast=linesInPage") else set /a "pageCnt+=1"

>"!outFile!" echo(%%PDF-1.1

for %%i in ("!outFile!") do set "objPos[1]=%%~zi"
>>"!outFile!" (
  echo(1 0 obj
  echo(^<^<
  echo(/CreationDate ^(D:!LocalDateTime!^)
  echo(/Producer ^(text2pdf.bat^)
  echo(/Title ^(text2pdf^)
  echo(^>^>
  echo(endobj
)

for %%i in ("!outFile!") do set "objPos[2]=%%~zi"
>>"!outFile!" (
  echo(2 0 obj
  echo(^<^<
  echo(/Type /Catalog
  echo(/Pages 3 0 R
  echo(^>^>
  echo(endobj
)

for %%i in ("!outFile!") do set "objPos[4]=%%~zi"
>>"!outFile!" (
  echo(4 0 obj
  echo(^<^<
  echo(/Type /Font
  echo(/Subtype /Type1
  echo(/Name /F1
  echo(/BaseFont /Courier
  echo(/Encoding /WinAnsiEncoding
  echo(^>^>
  echo(endobj
)

for %%i in ("!outFile!") do set "objPos[5]=%%~zi"
>>"!outFile!" (
  echo(5 0 obj
  echo(^<^<
  echo(/Font ^<^< /F1 4 0 R ^>^>
  echo(/ProcSet [ /PDF /Text ]
  echo(^>^>
  echo(endobj
)

<!inFile! (
  for /l %%h in (1 1 !pageCnt!) do (
    set /a "objects+=1, nextObject=objects+1, pages+=1"
    set "pageObj[!pages!]=!objects!"
    for %%i in ("!outFile!") do set "objPos[!objects!]=%%~zi"
    >>"!outFile!" (
      echo(!objects! 0 obj
      echo(^<^<
      echo(/Type /Page
      echo(/Parent 3 0 R
      echo(/Resources 5 0 R
      echo(/Contents !nextObject! 0 R
      echo(^>^>
      echo(endobj
    )

    set /a "objects+=1, nextObject+=1"
    for %%i in ("!outFile!") do set "objPos[!objects!]=%%~zi"
    >>"!outFile!" (
      echo(!objects! 0 obj
      echo(^<^<
      echo(/Length !nextObject! 0 R
      echo(^>^>
      echo(stream
    )

    for %%i in ("!outFile!") do set "streamPos=%%~zi"
    >>"!outFile!" (
      echo(BT
      echo(/F1 !fontSize! Tf
      echo(1 0 0 1 50 !hMinus40! Tm
      echo(!lineHight! TL
    )

    if %%h equ !pageCnt! (set "n=!linesInLast!") else set "n=!linesInPage!"
    >>"!outFile!" (
      for /l %%j in (1 1 !n!) do (
        set "ln="&set /p "ln="
        if defined ln call :proc_line
        echo(^(!ln!^)'
      )
      echo(^(^)'
      echo(ET
    )

    for %%i in ("!outFile!") do set /a "streamLen=%%~zi-streamPos"
    >>"!outFile!" (
      echo(endstream
      echo(endobj
    )

    set /a "objects+=1, nextObject+=1"
    for %%i in ("!outFile!") do set "objPos[!objects!]=%%~zi"
    >>"!outFile!" (
      echo(!objects! 0 obj
      echo(!streamLen!
      echo(endobj
    )
  )
)

for %%i in ("!outFile!") do set "objPos[3]=%%~zi"
>>"!outFile!" (
  echo(3 0 obj
  echo(^<^<
  echo(/Type /Pages
  echo(/Count !pages!
  echo(/MediaBox [ 0 0 !pageWidth! !pageHeight! ]
  <nul set /p "=/Kids [ "
  for /l %%i in (1 1 !pages!) do <nul set /p "=!pageObj[%%i]! 0 R "
  echo(]
  echo(^>^>
  echo(endobj
)

for %%i in ("!outFile!") do set "xrefPos=%%~zi"
>>"!outFile!" (
  echo(xref
  echo(0 !nextObject!
  <nul set /p "=0000000000 65535 f !cr!"
  for /l %%i in (1 1 !objects!) do (
    set "pos=0000000000!objPos[%%i]!"
    <nul set /p "=!pos:~-10! 00000 n !cr!"
  )

  echo(trailer
  echo(^<^<
  echo(/Size !nextObject!
  echo(/Root 2 0 R
  echo(/Info 1 0 R
  echo(^>^>

  echo(startxref
  echo(!xrefPos!
  echo(%%%%EOF
)
exit /b 0

:proc_line
for /f "tokens=1* delims=%tab%" %%i in ("X!ln!") do setlocal EnableExtensions DisableDelayedExpansion &if "%%j" neq "" (
  endlocal
  set "str=X!ln!"
  set "len=0"
  for /l %%k in (12 -1 0) do (
    set /a "len|=1<<%%k"
    for %%l in (!len!) do if "!str:~%%l,1!"=="" set /a "len&=~1<<%%k"
  )
  set /a "len-=1"
  call :tab_recur 0
) else endlocal
for %%i in ("\=\\" "(=\(" ")=\)") do set "ln=!ln:%%~i!"
exit /b

:tab_recur
if %1 lss !len! (
  set /a "nxt=%1+1"
  if "!ln:~%1,1!"=="%tab%" (
    set /a "d=0-(%1 %% tabWidth)+tabWidth, e=nxt, nxt+=d-1, len+=d-1"
    for /f "tokens=1,2" %%d in ("!d! !e!") do set "ln=!ln:~0,%1!!spcs:~0,%%d!!ln:~%%e!"
  )
  call :tab_recur !nxt!
)
exit /b

:help
echo(%~1
echo(
echo(Usage:
echo(txt2pdf.bat inFile outFile [/A4^|/A3^|/Letter] [/T:n] [/F:n] [/L]
echo(
echo(  inFile   Path of the source text file.
echo(  outFile  Path of the destination PDF file.
echo(
echo(  /A4      Page size A4.          (default)
echo(  /A3      Page size A3.
echo(  /Letter  Page size Letter.
echo(
echo(  /T:n     Tab width of n spaces. (default  8)
echo(  /F:n     Font size of n points. (default 10)
echo(  /L       Orientation Landscape. (default Portrait)
echo(
exit /b
